## appimagelauncher 2.2.0.ds1

=== lib/CMakeLists.txt ===
# required for pkg-config module's imported target feature
cmake_minimum_required(VERSION 3.6)

# note for self: include libappimage before AppImageUpdate to use the version here, not the one shipped with AppImageUpdate
# the AppImageUpdate submodule tends to be out of date
if(NOT USE_SYSTEM_LIBAPPIMAGE)
    add_subdirectory(libappimage EXCLUDE_FROM_ALL)
endif()

# used by the update helper
if(ENABLE_UPDATE_HELPER)
    set(BUILD_QT_UI On CACHE BOOL "" FORCE)
    add_subdirectory(AppImageUpdate EXCLUDE_FROM_ALL)
endif()

if(TRAVIS_BUILD)
    # TODO: use latest version of CMake once it contains the following change:
    # https://gitlab.kitware.com/cmake/cmake/commit/00a9d133fb2838ebb756d684659c5d51f577ede3
    # when this is available, the workaround here isn't necessary any more, instead install(TARGETS ...) can be used
    # and the BUILD_WITH_INSTALL_RPATH property doesn't need to be set any more
    message(WARNING "TRAVIS_BUILD is set to ON, binaries can only be tested after installation!")
    set(DEPS_RPATH "\$ORIGIN")
    set_property(TARGET libappimageupdate PROPERTY INSTALL_RPATH ${DEPS_RPATH})
    set_property(TARGET libappimageupdate PROPERTY BUILD_WITH_INSTALL_RPATH ON)
    set_property(TARGET libappimageupdate-qt PROPERTY INSTALL_RPATH ${DEPS_RPATH})
    set_property(TARGET libappimageupdate-qt PROPERTY BUILD_WITH_INSTALL_RPATH ON)
endif()

=== resources/CMakeLists.txt ===
# install configs for resource files

# we depend on GNUInstallDirs, so let's make sure it's been loaded
include(GNUInstallDirs)

# debugging: should be share
message(STATUS "CMAKE_INSTALL_DATADIR: ${CMAKE_INSTALL_DATADIR}")

install(
    DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}/mime
    DESTINATION ${CMAKE_INSTALL_DATADIR} COMPONENT APPIMAGELAUNCHER
)

install(
    DIRECTORY
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/hicolor
    DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/ COMPONENT APPIMAGELAUNCHER
)

install(
    FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/appimagelauncher.desktop
    ${CMAKE_CURRENT_SOURCE_DIR}/appimagelaunchersettings.desktop
    DESTINATION ${CMAKE_INSTALL_DATADIR}/applications COMPONENT APPIMAGELAUNCHER
)

install(
    DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/fallback-icons
    DESTINATION ${CMAKE_INSTALL_DATADIR}/appimagelauncher COMPONENT APPIMAGELAUNCHER
)
# we also need to copy the files into the binary dir to make their path predictable relative to the binary's location
file(
    COPY "${CMAKE_CURRENT_SOURCE_DIR}/fallback-icons"
    DESTINATION "${CMAKE_CURRENT_BINARY_DIR}"
)

set(INSTALL_MAINTAINER_SCRIPTS OFF CACHE BOOL "")

# install maintainer scripts that distro packagers might find useful
if (INSTALL_MAINTAINER_SCRIPTS)
    message(STATUS "Installing maintainer scripts")

    set(install_maintainer_scripts_dir ${PROJECT_BINARY_DIR}/cmake/install-maintainer-scripts/)

    configure_file(
        ${PROJECT_SOURCE_DIR}/resources/install-scripts/post-install.in
        ${install_maintainer_scripts_dir}/post-install
        @ONLY
    )
    configure_file(
        ${PROJECT_SOURCE_DIR}/resources/install-scripts/post-uninstall.in
        ${install_maintainer_scripts_dir}/post-uninstall
        @ONLY
    )

    install(
        FILES ${install_maintainer_scripts_dir}/post-install ${install_maintainer_scripts_dir}/post-uninstall
        DESTINATION ${CMAKE_INSTALL_DATADIR}/appimagelauncher/maintainer-scripts
    )
endif()


# install man page
set(INSTALL_MAN_PAGE ON CACHE BOOL "")

if(INSTALL_MAN_PAGE)
    set(configured_man_page_path ${PROJECT_BINARY_DIR}/cmake/man/AppImageLauncher.1)

    configure_file(
        ${PROJECT_SOURCE_DIR}/resources/AppImageLauncher.1.in
        ${configured_man_page_path}
    )

    install(
        FILES ${configured_man_page_path}
        DESTINATION share/man/man1 COMPONENT APPIMAGELAUNCHER
    )
endif()

=== src/CMakeLists.txt ===
# in version 3.6 IMPORTED_TARGET has been added to pkg_*_modules
cmake_minimum_required(VERSION 3.6)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
# Create code from a list of Qt designer ui files
set(CMAKE_AUTOUIC ON)
# Compile resource files
set(CMAKE_AUTORCC ON)

find_package(Qt5 REQUIRED COMPONENTS Core Widgets DBus)

find_package(PkgConfig REQUIRED)
pkg_check_modules(glib REQUIRED glib-2.0>=2.40 IMPORTED_TARGET)

find_package(INotify REQUIRED)

# disable Qt debug messages except for debug builds
if (NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    message(STATUS "CMake build type is ${CMAKE_BUILD_TYPE}, hence disabling debug messages in AppImageLauncher")
    add_definitions(-DQT_NO_DEBUG_OUTPUT)
    add_definitions(-DQT_NO_INFO_OUTPUT)
    add_definitions(-DQT_NO_WARNING_OUTPUT)
endif()

# this shall propagate to all targets built in the subdirs
if(ENABLE_UPDATE_HELPER)
    add_definitions(-DENABLE_UPDATE_HELPER)
endif()

add_compile_options(-Wall -Wpedantic)

if(BUILD_LITE)
    add_definitions(-DBUILD_LITE)
endif()

# utility libraries
add_subdirectory(fswatcher)
add_subdirectory(i18n)
add_subdirectory(trashbin)
add_subdirectory(shared)

# appimagelauncherd
add_subdirectory(daemon)

# main application and helper tools
add_subdirectory(ui)

# no need to include bypass launcher in lite builds
if(NOT BUILD_LITE)
    add_subdirectory(binfmt-bypass)
endif()

# CLI helper allowing other tools to utilize AppImageLauncher's code for e.g., integrating AppImages
add_subdirectory(cli)

=== lib/AppImageUpdate/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(AppImageUpdate)

# enable C++11
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# read Git revision ID
# WARNING: this value will be stored in the CMake cache
# to update it, you will have to reset the CMake cache
# (doesn't matter for CI builds like Travis for instance, where there's no permanent CMake cache)
execute_process(
    COMMAND git rev-parse --short HEAD
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_COMMIT
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

# set version and build number
set(VERSION 1-alpha)
if("$ENV{TRAVIS_BUILD_NUMBER}" STREQUAL "")
    set(BUILD_NUMBER "<local dev build>")
else()
    set(BUILD_NUMBER "$ENV{TRAVIS_BUILD_NUMBER}")
endif()

# get current date
execute_process(
    COMMAND env LC_ALL=C date -u "+%Y-%m-%d %H:%M:%S %Z"
    OUTPUT_VARIABLE DATE
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

# include external libraries
add_subdirectory(lib)

# core source directory, contains its own CMakeLists.txt
add_subdirectory(src)

# packaging
include(${PROJECT_SOURCE_DIR}/cmake/cpack-deb.cmake)

=== lib/libappimage/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)

project(libappimage)

set(V_MAJOR 1)
set(V_MINOR 0)
set(V_PATCH 3)
set(V_SUFFIX "")

set(libappimage_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH}${V_SUFFIX})

# more versioning
set(libappimage_SOVERSION ${V_MAJOR}.${V_MINOR})

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Optimize for size in release builds
set(CMAKE_CXX_FLAGS_RELEASE "-Os -DNDEBUG -Wl,--gc-sections")

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(cmake/reproducible_builds.cmake)

include(cmake/tools.cmake)
include(cmake/dependencies.cmake)

option(LIBAPPIMAGE_DESKTOP_INTEGRATION_ENABLED "Enable desktop integration functions" On)
option(LIBAPPIMAGE_THUMBNAILER_ENABLED "Enable thumbnailer functions" On)
option(LIBAPPIMAGE_STANDALONE "Statically embbed dependencies" Off)
option(ENABLE_COVERAGE "Enable tests code coverate target" Off)


if(ENABLE_COVERAGE)
    message("Configuring project for code coverage mesurement")
    include(CodeCoverage)
    append_coverage_compiler_flags()
endif()

# used by e.g., Debian packaging infrastructure
include(GNUInstallDirs)

add_subdirectory(lib)
add_subdirectory(src)

include(CTest)
add_subdirectory(tests)

=== lib/AppImageUpdate/lib/CMakeLists.txt ===
add_subdirectory(zsync2 EXCLUDE_FROM_ALL)

if(NOT TARGET libappimage)
    add_subdirectory(libappimage EXCLUDE_FROM_ALL)
endif()

=== lib/AppImageUpdate/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

set(CMAKE_POSITION_INDEPENDENT_CODE true)

# add support for sanitizers
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/lib/sanitizers-cmake/cmake" ${CMAKE_MODULE_PATH})
find_package(Sanitizers REQUIRED)

# required to link to correct thread library
find_package(Threads REQUIRED)
find_package(X11 REQUIRED)

if(NOT ${X11_Xpm_FOUND})
    message(FATAL_ERROR "libxpm could not be found!")
else()
    message(STATUS "Found libxpm: ${X11_Xpm_LIB}")
endif()

# expose version data as compiler definition
add_definitions("-DAPPIMAGEUPDATE_VERSION=\"${VERSION}\"")
add_definitions("-DAPPIMAGEUPDATE_GIT_COMMIT=\"${GIT_COMMIT}\"")
add_definitions("-DBUILD_DATE=\"${DATE}\"")
add_definitions("-DBUILD_NUMBER=\"${BUILD_NUMBER}\"")


# core library
add_library(
    libappimageupdate
    SHARED
    ${PROJECT_SOURCE_DIR}/include/appimage/update.h updater.cpp
    util.h
)
# since the target is called libsomething, one doesn't need CMake's additional lib prefix
set_target_properties(libappimageupdate
    PROPERTIES
    PREFIX ""
    PUBLIC_HEADER ${PROJECT_SOURCE_DIR}/include/appimage/update.h
)
# link thread libraries
target_link_libraries(libappimageupdate
    PUBLIC libappimage_shared
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
    PRIVATE libzsync2
    PRIVATE ${CPR_LIBRARIES}
)
# include directories, publicly
target_include_directories(libappimageupdate PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    # FIXME: works for now, but should be possible without these workaround
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/lib/zsync2/lib/cpr/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/lib/zsync2/include>
)


# core library
add_library(
    libappimageupdate_static
    STATIC
    ${PROJECT_SOURCE_DIR}/include/appimage/update.h updater.cpp
    util.h
)
# since the target is called libsomething, one doesn't need CMake's additional lib prefix
set_target_properties(libappimageupdate_static
    PROPERTIES
    PREFIX ""
    OUTPUT_NAME "libappimageupdate"
    PUBLIC_HEADER ${PROJECT_SOURCE_DIR}/include/appimage/update.h
)
# link thread libraries
target_link_libraries(libappimageupdate_static
    PUBLIC libappimage_shared
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
    PRIVATE libzsync2
    PRIVATE ${CPR_LIBRARIES}
)
# include directories, publicly
target_include_directories(libappimageupdate_static PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    # FIXME: works for now, but should be possible without these workaround
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/lib/zsync2/lib/cpr/include>
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/lib/zsync2/include>
)


# CLI application
add_executable(appimageupdatetool main.cpp)
# link to core lib
target_link_libraries(appimageupdatetool libappimageupdate args)

# set up rpath
set_target_properties(libappimageupdate libappimageupdate_static PROPERTIES INSTALL_RPATH "\$ORIGIN")
set_target_properties(appimageupdatetool PROPERTIES INSTALL_RPATH "\$ORIGIN/../lib")

# install targets
install(
    TARGETS libappimageupdate libappimageupdate_static appimageupdatetool
    RUNTIME DESTINATION bin COMPONENT APPIMAGEUPDATETOOL
    LIBRARY DESTINATION lib COMPONENT LIBAPPIMAGEUPDATE
    ARCHIVE DESTINATION lib COMPONENT LIBAPPIMAGEUPDATE
    PUBLIC_HEADER DESTINATION include/appimage COMPONENT LIBAPPIMAGEUPDATE-DEV
)


# include Qt UI
set(BUILD_QT_UI OFF CACHE BOOL "Build Qt UI (widget library and demo application)")
if(BUILD_QT_UI)
    add_subdirectory(qt-ui)
endif()

=== lib/libappimage/src/CMakeLists.txt ===
# required for pkg-config to create PkgConfig::<prefix> imported library targets
cmake_minimum_required(VERSION 3.6)

find_package(PkgConfig)

pkg_check_modules(glib glib-2.0>=2.40 IMPORTED_TARGET)
pkg_check_modules(gobject gobject-2.0>=2.40 IMPORTED_TARGET)
pkg_check_modules(gio gio-2.0>=2.40 IMPORTED_TARGET)
pkg_check_modules(zlib zlib IMPORTED_TARGET)
pkg_check_modules(cairo cairo IMPORTED_TARGET)

add_subdirectory(xdg-basedir)
add_subdirectory(libappimage_hashlib)
add_subdirectory(libappimage_shared)
add_subdirectory(libappimage)

# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE libappimage)

include(CMakePackageConfigHelpers)

# Create the AppImageConfig.cmake and AppImageConfigVersion files
configure_package_config_file(
    "${PROJECT_SOURCE_DIR}/cmake/libappimageConfig.cmake.in"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfig.cmake"
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
)
# ... for both
configure_file(
    "${PROJECT_SOURCE_DIR}/cmake/libappimageConfigVersion.cmake.in"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfigVersion.cmake"
    @ONLY
)

# Install the AppImageConfig.cmake and AppImageConfigVersion.cmake
install(
    FILES
    "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/libappimageConfig.cmake"
    "${PROJECT_BINARY_DIR}/${CMAKE_FILES_DIRECTORY}/libappimageConfigVersion.cmake"
    "${PROJECT_SOURCE_DIR}/cmake/scripts.cmake"
    "${PROJECT_SOURCE_DIR}/cmake/imported_dependencies.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
    COMPONENT libappimage-dev
)

# Install the export set for use with the install-tree
install(
    EXPORT libappimageTargets
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/libappimage
    COMPONENT libappimage-dev
)

# pkg-config
configure_file("${PROJECT_SOURCE_DIR}/cmake/libappimage.pc.in" "${PROJECT_BINARY_DIR}/libappimage.pc" @ONLY)

install(FILES "${PROJECT_BINARY_DIR}/libappimage.pc"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
    COMPONENT libappimage-dev
)

=== lib/libappimage/tests/CMakeLists.txt ===
# build and add test only if tests are enabled
include(CTest)
if(BUILD_TESTING)
    cmake_minimum_required(VERSION 3.5)

    # global definitions
    add_definitions(
        -DTEST_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data/"
        -DGIT_COMMIT="AppImageKit unit tests"
    )


    add_subdirectory(libappimage)

    if(ENABLE_COVERAGE)
        set(COVERAGE_LCOV_EXCLUDES '${PROJECT_SOURCE_DIR}/lib/*' '${PROJECT_SOURCE_DIR}/tests/*' '${PROJECT_SOURCE_DIR}/*build*' '/usr/*')
        setup_target_for_coverage_lcov(
            NAME coverage
            EXECUTABLE ctest -V -j ${PROCESSOR_COUNT}
            DEPENDENCIES test_libappimage++ TestDesktopIntegration test-xdg-basedir test_shared test_libappimage test_libappimage
        )
    endif()
endif()

=== src/cli/commands/CMakeLists.txt ===
add_library(cli_commands STATIC Command.h CommandFactory.cpp CommandFactory.h IntegrateCommand.cpp IntegrateCommand.h UnintegrateCommand.h UnintegrateCommand.cpp exceptions.h)
target_link_libraries(cli_commands PUBLIC Qt5::Core shared cli_logging)
target_include_directories(cli_commands PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== src/cli/logging/CMakeLists.txt ===
add_library(cli_logging INTERFACE)
set_property(TARGET cli_logging PROPERTY INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR})

=== lib/AppImageUpdate/lib/libappimage/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(libappimage)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

include(cmake/tools.cmake)
include(cmake/dependencies.cmake)

add_subdirectory(lib)
add_subdirectory(src)

include(CTest)
add_subdirectory(tests)

## appimagelauncher 2.2.0+dfsg

=== debian/changelog ===
appimagelauncher (2.2.0+dfsg-1+20201123+2101+amd64+build31) 2101+amd64; urgency=medium

  [ Scarlett Moore ]
  * New upstream release. 

  [ Debian CI ]
  * Automatic CI Build

 -- Debian CI <null@debian.org>  Mon, 08 Feb 2021 17:38:07 +0000

appimagelauncher (1.3.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #918523)

 -- Scarlett Moore <sgmoore@kde.org>  Sat, 05 Jan 2019 16:14:31 +0000

=== debian/control ===
Source: appimagelauncher
Section: utils
Priority: optional
Maintainer: Scarlett Moore <sgmoore@kde.org>
Build-Depends: cmake,
               debhelper (>= 12),
               libappimage-dev (>= 1.0.3~),
               libarchive-dev,
               libboost-filesystem1.67-dev,
               libboost1.67-dev,
               libcairo2-dev,
               libcurl-dev,
               libfuse-dev,
               libglib2.0-dev,
               librsvg2-dev,
               libxpm-dev,
               pkg-config,
               qtbase5-dev,
               qttools5-dev-tools
Standards-Version: 4.3.0
Homepage: https://github.com/TheAssassin/AppImageLauncher
Vcs-Git: https://github.com/dci-extras-packaging/appimagelauncher
Vcs-Browser: https://github.com/dci-extras-packaging/appimagelauncher

Package: appimagelauncher
Architecture: any
Pre-Depends: binfmt-support, dpkg-dev
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: AppImage helper
 Helper application for Linux distributions serving as a
 kind of "entry point" for running and integrating AppImages
 .librsvg-dev
 AppImage provides a way for upstream developers to provide
 “native” binaries for Linux users just the same way they could
 do for other operating systems. It allow packaging applications
 for any common Linux based operating system, e.g., Debian.
 AppImages come with all dependencies that cannot be assumed
 to be part of each target system in a recent enough version and
 will run on most Linux distributions without further modifications.
 .
 AppImageLauncher makes your Linux desktop AppImage ready™.
 You can integrate AppImages with a single mouse click, and manage
 them from your application launcher. Install AppImageLauncher today
 for your distribution and enjoy using AppImages as easy as never before!

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export QT_SELECT=5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_LIBAPPIMAGE=ON -DCMAKE_BUILD_TYPE=Release \
	-DENABLE_UPDATE_HELPER=OFF -DINSTALL_MAINTAINER_SCRIPTS=ON

override_dh_fixperms:
	dh_fixperms
	chmod +x $(CURDIR)/debian/appimagelauncher/usr/share/appimagelauncher/maintainer-scripts/post-install
	chmod +x $(CURDIR)/debian/appimagelauncher/usr/share/appimagelauncher/maintainer-scripts/post-uninstall

override_dh_shlibdeps:
	dh_shlibdeps -LXdgUtils -l/usr/lib/$(DEB_HOST_MULTIARCH)/XdgUtils

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//, \
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/TheAssassin/AppImageLauncher/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## appimagelauncher 2.2.0.ds1

=== debian/changelog ===
appimagelauncher (2.2.0.ds1-1~mx23+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Remove .git/modules/* from source, not necessary, and add ".ds1" to
    version.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 02 Dec 2024 18:32:19 -0800

appimagelauncher (2.2.0-7) bookworm; urgency=medium

  * Initial release. (Closes: #1.0)  <1.0 is the bug number of your ITP>

 -- linuxmangaka <linuxmangaka@gmail.com>  Mon, 05 Aug 2024 12:35:14 +0700

=== debian/control ===
Source: appimagelauncher
Section: utils
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: linuxmangaka <linuxmangaka@gmail.com>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               git,
               libappimage-dev,
               libarchive-dev,
               libboost-all-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libcairo2-dev,
               libcurl4-openssl-dev,
               libfuse-dev,
               libgdk-pixbuf-2.0-dev,
               libglib2.0-dev,
               libgtk-3-dev,
               libjpeg-dev,
               librsvg2-dev,
               libtiff-dev,
               libxpm-dev,
               patchelf,
               pkgconf,
               qtbase5-dev,
               qtdeclarative5-dev,
               qttools5-dev,
               qttools5-dev-tools
Standards-Version: 4.6.2
Homepage: https://assassinate-you.net/tags/appimagelauncher/
Vcs-Browser: https://salsa.debian.org/sgclark-guest/appimagelauncher
Vcs-Git: https://salsa.debian.org/sgclark-guest/appimagelauncher.git

Package: appimagelauncher
Architecture: any
Pre-Depends: binfmt-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: integrates your Linux desktop with AppImages
 Integrate AppImages to your application launcher with one click, and manage,
 update and remove them from there. Double-click AppImages to open them,
 without having to make them executable first. AppImageLauncher plays well with
 other applications managing AppImages, for example app stores. However, it
 doesn't depend on any of those, and can run completely standalone.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
# Read Git commit hash from Debian version (only works on Launchpad)
		head -n 1 debian/changelog | sed -nE "s|.*-([0-9a-f]{7})~[^~]*|\1|p" > cmake/GIT_COMMIT 

	dh_auto_configure -- -DUSE_SYSTEM_LIBAPPIMAGE=ON \
	-DCMAKE_BUILD_TYPE=Release \
	-DENABLE_UPDATE_HELPER=OFF \
	-DINSTALL_MAINTAINER_SCRIPTS=ON

override_dh_fixperms:
	dh_fixperms
	chmod +x $(CURDIR)/debian/appimagelauncher/usr/share/appimagelauncher/maintainer-scripts/post-install
	chmod +x $(CURDIR)/debian/appimagelauncher/usr/share/appimagelauncher/maintainer-scripts/post-uninstall

# No dbgsym packages:
override_dh_strip:
	@echo "not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## appimagelauncher 202110042218

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(AppImageLauncher)

# versioning
include(cmake/versioning.cmake)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/modules)

include(cmake/scripts.cmake)

include(cmake/reproducible_builds.cmake)

# support for ccache
# call CMake with -DUSE_CCACHE=ON to make use of it
set(USE_CCACHE OFF CACHE BOOL "")
if(USE_CCACHE)
    find_program(CCACHE ccache)
    if(CCACHE)
        message(STATUS "Using ccache")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE})
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE})
    else()
        message(WARNING "USE_CCACHE set, but could not find ccache")
    endif()
endif()

# used by Debian packaging infrastructure
include(GNUInstallDirs)

# if there's a system libappimage package on the system, we can use that directly
set(USE_SYSTEM_LIBAPPIMAGE OFF CACHE BOOL "")

# if the system version should be used, import globally _before_ including third-party stuff and own executables/libs
if(USE_SYSTEM_LIBAPPIMAGE)
    find_package(libappimage REQUIRED)
endif()

# optional; if AppImageUpdate dependency is not viable, the update helper can be disabled
set(ENABLE_UPDATE_HELPER ON CACHE BOOL "")

# install resources, bundle libraries privately, etc.
# initializes important installation destination variables, therefore must be included before adding subdirectories
include(cmake/install.cmake)

add_subdirectory(lib)
add_subdirectory(src)

# contains install configs for resource files
add_subdirectory(resources)

# translation management
add_subdirectory(i18n)

# packaging
include(cmake/cpack_general.cmake)
include(cmake/cpack_source.cmake)
include(cmake/cpack_deb.cmake)
include(cmake/cpack_rpm.cmake)

# must be the last instruction
include(CPack)

=== i18n/CMakeLists.txt ===
# lupdate must be installed and available
check_program(NAME lupdate)
check_program(NAME lrelease)

# create target calling custom commands
add_custom_target(i18n)

# create/update AppImageLauncher strings
function(ail_generate_translations)
    if(ARGC LESS 2)
        message(ERROR "ail_generate_translations called with wrong amount of arguments")
    endif()

    add_custom_command(
        TARGET i18n POST_BUILD
        COMMAND ${LUPDATE} "${ARGV0}" -ts "${ARGV1}" -locations relative
        MAIN_DEPENDENCY "${ARGV0}"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}

    )
endfunction()

ail_generate_translations(../src/ ui.en.ts)

file(GLOB TS_FILES *.ts)

foreach(TS_FILE IN LISTS TS_FILES)
    get_filename_component(TS_FILENAME ${TS_FILE} NAME)
    ail_generate_translations(../src/ ${TS_FILENAME})
endforeach()

add_custom_command(
    TARGET i18n POST_BUILD
    COMMAND ./auto-translate.py ui.en.ts
    MAIN_DEPENDENCY "${ARGV0}"
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)


add_custom_target(l10n ALL)

# generate Qt qm files from translation source files
function(ail_generate_qm)
    if(ARGC LESS 2)
        message(ERROR "ail_generate_translations called with wrong amount of arguments")
    endif()

    add_custom_command(
        TARGET l10n POST_BUILD
        COMMAND ${LRELEASE} "${ARGV0}" -qm "${ARGV1}"
        MAIN_DEPENDENCY "${ARGV0}"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}

    )
endfunction()

file(GLOB TS_FILES *.ts)

set(target_dir ${CMAKE_CURRENT_BINARY_DIR}/generated/l10n)

foreach(TS_FILE IN LISTS TS_FILES)
    get_filename_component(TS_FILENAME ${TS_FILE} NAME)
    string(REPLACE .ts .qm QM_FILENAME ${TS_FILENAME})
    ail_generate_qm(${TS_FILENAME} ${target_dir}/${QM_FILENAME})
endforeach()

# deploy JSON files
file(GLOB JSON_FILES *.json)

foreach(JSON_FILE IN LISTS JSON_FILES)
    get_filename_component(JSON_FILENAME ${JSON_FILE} NAME)
    add_custom_command(
        TARGET l10n POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy ${JSON_FILENAME} ${target_dir}/${JSON_FILENAME}
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
        MAIN_DEPENDENCY ${JSON_FILE}
    )
endforeach()


# empty directories aren't tracked by Git
# therefore the directory needs to be created by CMake
file(MAKE_DIRECTORY ${target_dir})

install(
    DIRECTORY ${target_dir}
    DESTINATION ${CMAKE_INSTALL_DATADIR}/appimagelauncher COMPONENT APPIMAGELAUNCHER
)

=== src/binfmt-bypass/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)
project(appimage-binfmt-bypass)

# configure names globally
set(bypass_bin binfmt-bypass)
set(preload_lib binfmt-bypass-preload)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# library to be preloaded when launching the patched runtime binary
# we need to build with -fPIC, otherwise we can't use it with $LD_PRELOAD
add_library(${preload_lib} SHARED preload.c logging.h)
target_compile_options(${preload_lib} PRIVATE -fPIC -DCOMPONENT_NAME="lib")
target_link_libraries(${preload_lib} PRIVATE dl)

# binary that extracts the runtime, patches it and launches it, preloading the library
add_executable(${bypass_bin} main.cpp elf.cpp logging.h elf.h)
target_link_libraries(${bypass_bin} PRIVATE dl)
target_compile_options(${bypass_bin} PRIVATE -DPRELOAD_LIB_NAME="$<TARGET_FILE_NAME:${preload_lib}>" -DCOMPONENT_NAME="bin" -D_GNU_SOURCE)

include(CheckCSourceCompiles)
message(STATUS "Checking whether memfd_create(...) is available")
check_c_source_compiles("
    #define _GNU_SOURCE
    #include <sys/mman.h>
    int main(int argc, char** argv) {
        memfd_create(\"test\", 0);
    }
    "
    HAVE_MEMFD_CREATE
)

if(HAVE_MEMFD_CREATE)
    target_compile_options(${bypass_bin} PRIVATE -DHAVE_MEMFD_CREATE)
else()
    message(WARNING "memfd_create not available, falling back to shm_open")
    target_link_libraries(${bypass_bin} PRIVATE rt)
endif()

# the binary uses the library, so let's make sure it's up to date before we build the bypass binary
add_dependencies(${bypass_bin} ${preload_lib})

# no need to set rpath on bypass binary, it doesn't depend on any private libraries
# the preload lib is used via its absolute path anyway

install(
    TARGETS ${bypass_bin} ${preload_lib}
    RUNTIME DESTINATION ${_private_libdir} COMPONENT APPIMAGELAUNCHER
    LIBRARY DESTINATION ${_private_libdir} COMPONENT APPIMAGELAUNCHER
)

=== src/cli/CMakeLists.txt ===
add_subdirectory(logging)

add_subdirectory(commands)

add_executable(ail-cli cli_main.cpp)
target_link_libraries(ail-cli PUBLIC cli_commands cli_logging)

set_property(
    TARGET ail-cli
    PROPERTY INSTALL_RPATH ${_rpath}
)

install(
    TARGETS ail-cli
    DESTINATION ${_bindir} COMPONENT APPIMAGELAUNCHER_CLI
)

=== src/daemon/CMakeLists.txt ===
# daemon binary
add_executable(appimagelauncherd main.cpp worker.cpp worker.h)
target_link_libraries(appimagelauncherd shared filesystemwatcher PkgConfig::glib libappimage)
set_target_properties(appimagelauncherd PROPERTIES INSTALL_RPATH ${_rpath})

install(
    TARGETS
    appimagelauncherd
    RUNTIME DESTINATION ${_bindir} COMPONENT APPIMAGELAUNCHER
    LIBRARY DESTINATION ${_libdir} COMPONENT APPIMAGELAUNCHER
)

=== src/fswatcher/CMakeLists.txt ===
add_library(filesystemwatcher STATIC filesystemwatcher.cpp filesystemwatcher.h)
target_link_libraries(filesystemwatcher PUBLIC Qt5::Core shared)
target_include_directories(filesystemwatcher PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== src/i18n/CMakeLists.txt ===
add_library(translationmanager translationmanager.cpp translationmanager.h)
target_link_libraries(translationmanager PUBLIC Qt5::Core Qt5::Widgets shared)
target_include_directories(translationmanager PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
add_dependencies(translationmanager l10n)

=== src/shared/CMakeLists.txt ===
add_library(shared STATIC shared.h shared.cpp types.h)
target_link_libraries(shared PUBLIC PkgConfig::glib Qt5::Core Qt5::Widgets Qt5::DBus libappimage translationmanager trashbin)
if(ENABLE_UPDATE_HELPER)
    target_link_libraries(shared PUBLIC libappimageupdate)
endif()
target_compile_definitions(shared
    PRIVATE -DPRIVATE_LIBDIR="${_private_libdir}"
    PRIVATE -DCMAKE_PROJECT_SOURCE_DIR="${PROJECT_SOURCE_DIR}"
)
target_include_directories(shared PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== src/trashbin/CMakeLists.txt ===
add_library(trashbin STATIC trashbin.cpp trashbin.h)
target_link_libraries(trashbin PUBLIC Qt5::Core libappimage shared)
target_include_directories(translationmanager PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

=== src/ui/CMakeLists.txt ===
if(NOT BUILD_LITE)
    # main AppImageLauncher application
    add_executable(AppImageLauncher main.cpp resources.qrc first-run.cpp first-run.h first-run.ui)
    target_link_libraries(AppImageLauncher shared PkgConfig::glib libappimage shared)

    # set binary runtime rpath to make sure the libappimage.so built and installed by this project is going to be used
    # by the installed binaries (be it the .deb, the AppImage, or whatever)
    # in order to make the whole install tree relocatable, a relative path is used
    set_target_properties(AppImageLauncher PROPERTIES INSTALL_RPATH ${_rpath})

    install(
        TARGETS
        AppImageLauncher
        RUNTIME DESTINATION ${_bindir} COMPONENT APPIMAGELAUNCHER
        LIBRARY DESTINATION ${_libdir} COMPONENT APPIMAGELAUNCHER
    )
endif()

# AppImageLauncherSettings application
add_executable(AppImageLauncherSettings settings_main.cpp resources.qrc settings_dialog.ui settings_dialog.cpp)
target_link_libraries(AppImageLauncherSettings shared)

# set binary runtime rpath to make sure the libappimage.so built and installed by this project is going to be used
# by the installed binaries (be it the .deb, the AppImage, or whatever)
# in order to make the whole install tree relocatable, a relative path is used
set_target_properties(AppImageLauncherSettings PROPERTIES INSTALL_RPATH ${_rpath})

install(
    TARGETS
    AppImageLauncherSettings
    RUNTIME DESTINATION ${_bindir} COMPONENT APPIMAGELAUNCHER
    LIBRARY DESTINATION ${_libdir} COMPONENT APPIMAGELAUNCHER
)

# AppImage removal helper
add_executable(remove remove_main.cpp remove.ui resources.qrc)
target_link_libraries(remove shared translationmanager libappimage)
# see AppImageLauncher for a description
set_target_properties(remove PROPERTIES INSTALL_RPATH "\$ORIGIN")

install(
    TARGETS remove
    RUNTIME DESTINATION ${_private_libdir} COMPONENT APPIMAGELAUNCHER
)


# AppImage update helper
if(ENABLE_UPDATE_HELPER)
    add_executable(update update_main.cpp resources.qrc)
    target_link_libraries(update shared translationmanager libappimage libappimageupdate-qt)
    # see AppImageLauncher for a description
    set_target_properties(update PROPERTIES INSTALL_RPATH "\$ORIGIN")

    install(
        TARGETS update
        RUNTIME DESTINATION ${_private_libdir} COMPONENT APPIMAGELAUNCHER
    )
endif()

=== debian/changelog ===
appimagelauncher (202110042218-0f91801~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.
  * Switch to source/format 3.0 (quilt).

 -- SwampRabbit <swamprabbit@mxlinux.org>  Wed, 12 Jan 2022 09:00:51 -0500

appimagelauncher (202110042218-stable-0f91801~ubuntu21.10.1) impish; urgency=low

  * Auto build.

 -- Launchpad Package Builder <noreply@launchpad.net>  Mon, 04 Oct 2021 22:18:19 +0000

appimagelauncher (1.2.2+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #918523)

 -- Scarlett Moore <sgmoore@kde.org>  Sat, 05 Jan 2019 16:14:31 +0000

=== debian/control ===
Source: appimagelauncher
Section: utils
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Scarlett Moore <sgmoore@kde.org>
Build-Depends: cmake,
               debhelper (>= 12),
               libappimage-dev,
               libboost-filesystem-dev,
               libboost-dev,
               libcairo2-dev,
               libfuse-dev,
               libglib2.0-dev,
               pkg-config,
               qtbase5-dev,
               qttools5-dev-tools,
               gcc-multilib [amd64],
               g++-multilib [amd64],
Standards-Version: 4.3.0
Homepage: https://github.com/TheAssassin/AppImageLauncher
Vcs-Browser: https://salsa.debian.org/sgclark-guest/appimagelauncher
Vcs-Git: https://salsa.debian.org/sgclark-guest/appimagelauncher.git

Package: appimagelauncher
Architecture: any
Pre-Depends: binfmt-support
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: AppImage helper
 Helper application for Linux distributions serving as a
 kind of "entry point" for running and integrating AppImages
 .
 AppImage provides a way for upstream developers to provide
 “native” binaries for Linux users just the same way they could
 do for other operating systems. It allow packaging applications
 for any common Linux based operating system, e.g., Debian.
 AppImages come with all dependencies that cannot be assumed
 to be part of each target system in a recent enough version and
 will run on most Linux distributions without further modifications.
 .
 AppImageLauncher makes your Linux desktop AppImage ready™.
 You can integrate AppImages with a single mouse click, and manage
 them from your application launcher. Install AppImageLauncher today
 for your distribution and enjoy using AppImages as easy as never before!

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export QT_SELECT=5

%:
	dh $@

override_dh_strip:
	dh_strip --no-automatic-dbgsym

override_dh_auto_configure:
	head -n 1 debian/changelog | sed -nE "s|.*-([0-9a-f]{7})~[^~]*|\1|p" > cmake/GIT_COMMIT # Read Git commit hash from Debian version (only works on Launchpad)
	dh_auto_configure -- 	-DUSE_SYSTEM_LIBAPPIMAGE=ON -DCMAKE_BUILD_TYPE=Release \
	-DENABLE_UPDATE_HELPER=OFF -DINSTALL_MAINTAINER_SCRIPTS=ON

override_dh_fixperms:
	dh_fixperms
	chmod +x $(CURDIR)/debian/appimagelauncher/usr/share/appimagelauncher/maintainer-scripts/post-install
	chmod +x $(CURDIR)/debian/appimagelauncher/usr/share/appimagelauncher/maintainer-scripts/post-uninstall

=== debian/watch ===
version=4
opts="repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//, \
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/TheAssassin/AppImageLauncher/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
